/**
* user:  A1001
* fname: Aleksandar
* lname: Krastev
* task:  clubs
* score: 30.0
* date:  2017-11-25 10:17:23.544748
*/
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>

uint32_t club_cnt(uint32_t n) {
	uint32_t c = 0;
	uint32_t k = 1;
	while (k < n) {
		k *= 2;
		c++;
	}
	return c;
}

void print_bin(uint32_t a, uint32_t c) {
	for (uint32_t i = c - 1;i < c;i--) {
		std::cout << ((a & (1U << i)) > 0);
	}
	std::cout << "\n";
}

uint32_t n;
uint32_t c;
/*
void print_sol(uint32_t mask) {
	for (uint32_t i = 0;i < (1U << c);i++) {
		if (mask & (1U << i)) {
			print_bin(i, c);
		}
	}
}

uint32_t check_sol(uint32_t mask) {
	std::vector<uint32_t> bitCnt;
	bitCnt.resize(c);
	uint32_t numCnt = 0;
	for (uint32_t i = 0;i < (1u << c);i++) {
		if (mask & (1u << i)) {
			numCnt++;
			for (uint32_t j = 0;j < c;j++) {
				if (i & (1u << j)) {
					bitCnt[j]++;
				}
			}
		}
	}
	if (numCnt != n) {
		return 1000;
	}
	uint32_t ans = 0;
	for (uint32_t i : bitCnt) {
		ans = std::max(ans, i);
	}
	return ans;
}
*/

uint32_t possibNums;
const uint32_t MAX_N = 1.1e5;
bool used[MAX_N];

std::vector<uint32_t> curCnt;
uint32_t cmax = 0;

uint32_t best_pick() {
	
	uint32_t bestNum = 0;
	uint32_t bestMax = 100;
	uint32_t bestNotMax = 100;
	for (uint32_t i = 0;i < possibNums;i++) {
		if (used[i]) {
			continue;
		}
		uint32_t curMax = 0;
		uint32_t curNotMax = 0;
		for (uint32_t j = 0;j < curCnt.size();j++) {
			if (i & (1u << j)) {
				if (curCnt[j] == cmax) {
					curMax++;
				} else {
					curNotMax++;
				}
			}
		}

		if (curMax < bestMax) {
			bestNum = i;
			bestMax = curMax;
			bestNotMax = curNotMax;
		} else if ((curMax == bestMax) && (curNotMax < bestNotMax)) {
			bestNum = i;
			bestNotMax = curNotMax;
		}
	}
	for (uint32_t j = 0;j < curCnt.size();j++) {
		if (bestNum & (1u << j)) {
			curCnt[j]++;
		}
	}
	used[bestNum] = true;

	for (uint32_t i : curCnt) {
		cmax = std::max(cmax, i);
	}

	return bestNum;
}

void print_ans(std::vector<uint32_t> &ans) {
	std::cout << c << " " << cmax << "\n";
	for (uint32_t i = 0;i < c;i++) {
		std::cout << curCnt[i] << " ";
		for (uint32_t j = 0;j < ans.size();j++) {
			if (ans[j] & (1u << i)) {
				//std::cout << ans[j] << "-";
				std::cout << j + 1 << " ";
			}
		}
		std::cout << "\n";
	}
}

int main() {
	std::cin >> n;
	c = club_cnt(n);
	possibNums = 1U << c;
	std::vector<uint32_t> ans;

	curCnt.resize(c);
	for (uint32_t &i : curCnt) {
		i = 0;
	}
	
	if (possibNums == n) {
		for (uint32_t i = 0;i < n;i++) {
			ans.push_back(i);
		}
		//curCnt.pop_back();
		//c--;
		for (uint32_t i = 0;i < c;i++) {
			curCnt[i] = n / 2;
		}
		cmax = n / 2;
	} else {
		for (uint32_t i = 0;i < n;i++) {
			ans.push_back(best_pick());
		}
	}
	print_ans(ans);

	/*uint32_t bestMask = 0;
	uint32_t bestCnt = 100;
	for (uint32_t i = 0;i < (1u << (1u << c));i++) {
		uint32_t cur = check_sol(i);
		if (cur < bestCnt) {
			bestCnt = cur;
			bestMask = i;
		}
	}
	std::cout << bestCnt << "\n";
	print_sol(bestMask);*/
}
