/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 07:44:17.773824
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 257;

struct edge {
    int from,to,w;
    edge(){}
    edge(int a, int b, int c): from(a), to(b), w(c) {}
};

int n,color[N][N];
vector < int > v1[N],v2[N];
int cnt1,cnt2;
bool used[N];
vector < edge > v;
pair < int, int > state;

void add_edge1(int a, int b) {
    v1[a].push_back(b);
    v1[b].push_back(a);
}

void add_edge2(int a, int b) {
    v2[a].push_back(b);
    v2[b].push_back(a);
}

void dfs1(int node) {
    used[node]=true;
    ++cnt1;
    for(int i=0;i<(int)(v1[node].size());i++) {
        if(!used[v1[node][i]]) dfs1(v1[node][i]);
    }
}

void dfs2(int node) {
    used[node]=true;
    ++cnt2;
    for(int i=0;i<(int)(v2[node].size());i++) {
        if(!used[v2[node][i]]) dfs2(v2[node][i]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d", &n);
    for(i=1;i<=n;i++) {
        for(j=1;j<=n;j++) {
            scanf("%d", &color[i][j]);
            if(j>i) v.push_back(edge(i,j,color[i][j]));
        }
    }
    scanf("%d %d", &state.first, &state.second);

    if(n<=7) {
        int which,ans=100000;

        for(i=0;i<(1<<v.size());i++) {
            int bitcnt=0;
            for(j=1;j<=n;j++) v1[j].clear(),v2[j].clear();

            for(j=0;j<(int)(v.size());j++) {
                if(i&(1<<j)) {
                    v[j].w^=1;
                    ++bitcnt;
                }
                if(v[j].w==0) {
                    add_edge1(v[j].from,v[j].to);
                }
                else {
                    add_edge2(v[j].from,v[j].to);
                }
            }
            
            for(j=1;j<=n;j++) used[j]=false;
            cnt1=0;
            dfs1(1);

            for(j=1;j<=n;j++) used[j]=false;
            cnt2=0;
            dfs2(1);

            pair < int, int > curr=make_pair(cnt1==n ? 1 : 0, cnt2==n ? 1 : 0);
            if(curr==state) {
                if(bitcnt<ans) {
                    ans=bitcnt;
                    which=i;
                }
            }
            for(j=0;j<(int)(v.size());j++) if(i&(1<<j)) {
                v[j].w^=1;
            }
        }
        
        if(ans==100000) {
            printf("-1\n");
            return 0;
        }

        printf("%d\n", ans);
        for(j=0;j<(int)(v.size());j++) if(which&(1<<j)) {
            printf("%d %d\n", v[j].from, v[j].to);
        }

        return 0;
    }

    return 0;
}
