/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  colorgraph
* score: 40.0
* date:  2017-11-25 11:34:45.975432
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 254;

struct edge {
    int from,to,w;
    edge(){}
    edge(int a, int b, int c): from(a), to(b), w(c) {}
};

int n,a[N][N];
vector < int > v1[N],v2[N];
bool used[N];
int cnt1,cnt2;
pair < int, int > state,curr_state;
vector < edge > v;
vector < int > g[N];
vector < int > curr;
vector < vector < int > > comp;

void add_edge1(int a, int b) {
    v1[a].push_back(b);
    v1[b].push_back(a);
}

void add_edge2(int a, int b) {
    v2[a].push_back(b);
    v2[b].push_back(a);
}

void dfs1(int node) {
    used[node]=true;
    ++cnt1;
    for(int i=0;i<(int)(v1[node].size());i++) if(!used[v1[node][i]]) dfs1(v1[node][i]);
}

void dfs2(int node) {
    used[node]=true;
    ++cnt2;
    for(int i=0;i<(int)(v2[node].size());i++) if(!used[v2[node][i]]) dfs2(v2[node][i]);
}

void dfs(int node) {
    curr.push_back(node);
    used[node]=true;
    for(int i=0;i<(int)(g[node].size());i++) if(!used[g[node][i]]) dfs(g[node][i]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d", &n);
    for(i=1;i<=n;i++) {
        for(j=1;j<=n;j++) {
			scanf("%d", &a[i][j]);
            if(j>i) v.push_back(edge(i,j,a[i][j]));
			if(j>i) {
                if(a[i][j]==0) {
                    v1[i].push_back(j);
                    v1[j].push_back(i);
                }
                else {
                    v2[i].push_back(j);
                    v2[j].push_back(i);
                }
            }
        }
    }
    scanf("%d %d", &state.first, &state.second);

    if(state==make_pair(0,0)) {
        printf("-1\n");
        return 0;
    }

    if(state==make_pair(1,1) && n<=3) {
        printf("-1\n");
        return 0;
    }

   	if(n<=7) {
        int which,ans=100000;

        for(i=0;i<(1<<v.size());i++) {
            int bitcnt=0;
            for(j=1;j<=n;j++) v1[j].clear(),v2[j].clear();

            for(j=0;j<(int)(v.size());j++) {
                if(i&(1<<j)) {
                    v[j].w^=1;
                    ++bitcnt;
                }
                if(v[j].w==0) {
                    add_edge1(v[j].from,v[j].to);
                }
                else {
                    add_edge2(v[j].from,v[j].to);
                }
            }
            
            for(j=1;j<=n;j++) used[j]=false;
            cnt1=0;
            dfs1(1);

            for(j=1;j<=n;j++) used[j]=false;
            cnt2=0;
            dfs2(1);

            pair < int, int > curr=make_pair(cnt1==n ? 1 : 0, cnt2==n ? 1 : 0);
            if(curr==state) {
                if(bitcnt<ans) {
                    ans=bitcnt;
                    which=i;
                }
            }
            for(j=0;j<(int)(v.size());j++) if(i&(1<<j)) {
                v[j].w^=1;
            }
        }
        
        if(ans==100000) {
            printf("-1\n");
            return 0;
        }

        printf("%d\n", ans);
        for(j=0;j<(int)(v.size());j++) if(which&(1<<j)) {
            printf("%d %d\n", v[j].from, v[j].to);
        }

        return 0;
    }
 

    memset(used,0,sizeof(used));
    dfs1(1);
    memset(used,0,sizeof(used));
    dfs2(1);
    curr_state=make_pair(cnt1==n ? 1 : 0, cnt2==n ? 1 : 0);

    if(state==curr_state) {
        printf("0\n");
        return 0;
    }

    //Gotta disconnect the blue one
    if(state==make_pair(1,0)) {
        int ans=10000;
        for(i=1;i<=n;i++) ans=min(ans,(int)(v2[i].size()));
        printf("%d\n", ans);
        for(i=1;i<=n;i++) if(ans==v2[i].size()) {
            for(j=0;j<(int)(v2[i].size());j++) printf("%d %d\n", i, v2[i][j]);
            return 0;
        }
    }

    //Gotta disconnect the red one
    if(state==make_pair(0,1)) {
        int ans=10000;
        for(i=1;i<=n;i++) ans=min(ans,(int)(v1[i].size()));
        printf("%d\n", ans);
        for(i=1;i<=n;i++) if(ans==v1[i].size()) {
            for(j=0;j<(int)(v1[i].size());j++) printf("%d %d\n", i, v1[i][j]);
            return 0;
        }
    }

    //State is (1,1)

    //We want to connect the red ones
    if(curr_state.first==0) {
        memset(used,0,sizeof(used));
        for(i=1;i<=n;i++) for(j=i+1;j<=n;j++) if(a[i][j]==0) g[i].push_back(j),g[j].push_back(i);
        for(i=1;i<=n;i++) if(!used[i]) {
            curr.clear();
            dfs(i);
            //random_shuffe(curr.begin(),curr.end());
            comp.push_back(curr);
        }
    }
    
    //We want to connect the blue ones
    else {
        memset(used,0,sizeof(used));
        for(i=1;i<=n;i++) for(j=i+1;j<=n;j++) if(a[i][j]==1) g[i].push_back(j),g[j].push_back(i);
        for(i=1;i<=n;i++) if(!used[i]) {
            curr.clear();
            dfs(i);
            //random_shuffle(curr.begin(),curr.end());
            comp.push_back(curr);
        }
    }

    //random_shuffle(comp.begin(),comp.end());
    printf("%d\n", (int)(comp.size())-1);
    for(i=1;i<(int)(comp.size());i++) {
        printf("%d %d\n", comp[i-1].back(), comp[i].front());
    }

    return 0;
}
