/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 08:00:54.659309
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (252);

int read_int();

struct dsu
{
    int n;
    vector<int> par, sz;

    void init(int S)
    {
        n = S;
        par.resize(n + 1);
        sz.resize(n + 1);
        for(int i = 0; i <= n; i++)
            sz[i] = 1, par[i] = i;
    }

    int root(int x) { return (x == par[x]) ? x : (par[x] = root(par[x])); }

    void unite(int u, int v)
    {
        u = root(u);
        v = root(v);
        if(u == v) return;
        if(sz[u] > sz[v]) swap(u, v);
        par[u] = v;
        sz[v] += sz[u];
    }

} d[2];

int n;
int G[MAXN][MAXN];
int A, B;

void read()
{
    cin >> n;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> G[i][j];
    cin >> A >> B;
}

void solve()
{
    if(n <= 7)
    {
        int cnt = n * (n - 1) / 2;
        for(int mask = 0; mask < (1 << cnt); mask++)
        {
            int C = 0;
            d[0].init(n);
            d[1].init(n);

            for(int i = 0; i < n; i++)
                for(int j = i + 1; j < n; j++)
                    if((1 << (i * n + j)) & mask)
                    {
                        C++;
                        d[G[i][j] ^ 1].unite(i, j);
                    }
                    else d[G[i][j]].unite(i, j);

            int m1 = 0, m2 = 0;
            for(int i = 0; i < n; i++)
            {
                if(d[0].root(i) == i) m1++;
                if(d[1].root(i) == i) m2++;
            }

            if(m1 == 1 && m2 == 1)
            {
                cout << C << endl;

                for(int i = 0; i < n; i++)
                    for(int j = i + 1; j < n; j++)
                        if((1 << (i * n + j)) & mask)
                            cout << i + 1 << " " << j + 1 << endl;

                return;
            }
        }

        cout << -1 << endl;
        return;
    }

    cout << -1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

