/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 08:37:53.461700
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (252);

int read_int();

struct dsu
{
    int n;
    vector<int> par, sz;

    void init(int S)
    {
        n = S;
        par.resize(n + 1);
        sz.resize(n + 1);
        for(int i = 0; i <= n; i++)
            sz[i] = 1, par[i] = i;
    }

    int root(int x) { return (x == par[x]) ? x : (par[x] = root(par[x])); }

    bool connected(int i, int j)
    {
        if(root(i) == root(j)) return true;
        return false;
    }

    void unite(int u, int v)
    {
        u = root(u);
        v = root(v);
        if(u == v) return;
        if(sz[u] > sz[v]) swap(u, v);
        par[u] = v;
        sz[v] += sz[u];
    }
} d[2];

int n;
int G[MAXN][MAXN];
int A, B;

void read()
{
    cin >> n;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> G[i][j];
    cin >> A >> B;
}

vector<int> li[30];

int popcnt(int x)
{
    int ret = 0;
    while(x) ret += (x & 1), x >>= 1;
    return ret;
}

void solve11()
{
    vector<pair<int, int> > answer;
    while(true)
    {
        d[0].init(n);
        d[1].init(n);

        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                if(G[i][j] == 0) d[0].unite(i, j);

        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                if(G[i][j] == 1)
                {
                    if(d[1].connected(i, j) && !d[0].connected(i, j))
                    {
                        G[i][j] ^= 1;
                        answer.push_back({i, j});
                        d[0].unite(i, j);
                    }

                    d[1].unite(i, j);
                }

        d[0].init(n);
        d[1].init(n);

        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                if(G[i][j] == 1) d[1].unite(i, j);

        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                if(G[i][j] == 0)
                {
                    if(d[0].connected(i, j) && !d[1].connected(i, j))
                    {
                        G[i][j] ^= 1;
                        answer.push_back({i, j});
                        d[1].unite(i, j);
                    }

                    d[0].unite(i, j);
                }


        int m1 = 0, m2 = 0;
        for(int i = 0; i < n; i++)
        {
            if(d[0].root(i) == i) m1++;
            if(d[1].root(i) == i) m2++;
        }

        if(m1 != 1) m1 = 0;
        if(m2 != 1) m2 = 0;

        cout << answer.size() << endl << flush;

        if(m1 == A && m2 == B)
        {
            cout << answer.size() << endl;
            for(auto it: answer)
                cout << it.first << " " << it.second << endl;
            return;
        }
    }

}

void solve()
{
    if(n <= 7)
    {
        int cnt = n * (n - 1) / 2;

        vector<pair<int, int> > ed;
        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                ed.push_back({i, j});

        for(int mask = 0; mask < (1 << cnt); mask++)
            li[popcnt(mask)].push_back(mask);

        for(int bitcnt = 0; bitcnt < 30; bitcnt++)
            for(int mask: li[bitcnt])
            {
                int C = 0;
                d[0].init(n);
                d[1].init(n);

                for(int idx = 0; idx < (int)ed.size(); idx++)
                {
                    int i = ed[idx].first, j = ed[idx].second;
                    if((1 << idx) & mask)
                    {
                        C++;
                        d[G[i][j] ^ 1].unite(i, j);
                    }
                    else d[G[i][j]].unite(i, j);
                }

                int m1 = 0, m2 = 0;
                for(int i = 0; i < n; i++)
                {
                    if(d[0].root(i) == i) m1++;
                    if(d[1].root(i) == i) m2++;
                }

                if(m1 != 1) m1 = 0;
                if(m2 != 1) m2 = 0;

                if(m1 == A && m2 == B)
                {
                    cout << C << endl;
                    for(int idx = 0; idx < (int)ed.size(); idx++)
                    {
                        int i = ed[idx].first, j = ed[idx].second;
                        if((1 << idx) & mask)
                            cout << i + 1 << " " << j + 1 << endl;
                    }

                    return;
                }
            }

        cout << -1 << endl;
        return;
    }

    d[0].init(n);
    d[1].init(n);

    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            d[G[i][j]].unite(i, j);

    int m1 = 0, m2 = 0;
    for(int i = 0; i < n; i++)
    {
        if(d[0].root(i) == i) m1++;
        if(d[1].root(i) == i) m2++;
    }

    if(m1 != 1) m1 = 0;
    if(m2 != 1) m2 = 0;

    if(m1 == A && m2 == B)
    {
        cout << 0 << endl;
        return;
    }

    if(B == 1 && A == 1)
    {
        solve11();
        return;
    }

    cout << -1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

