/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  crypto
* score: 10.0
* date:  2017-11-25 10:03:53.199049
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (411);
const int mod = (int)1e9 + 7;

int read_int();

int n, p, k;

void read()
{
    cin >> n >> k >> p;
}

int dp[MAXN * MAXN / 2][MAXN];

int prec[MAXN][MAXN];

int rec(int n, int p)
{
    if(p < 0) return 0;
    if(n == 0) return p == 0;

    int &memo = dp[p][n];
    if(memo != -1) return memo;

    memo = 0;
    if(n < k) memo = (rec(n - 1, p) * 1ll * n) % mod;
    else for(int K = 1; K <= k; K++)
        memo = (memo + (prec[n][K] * 1ll * rec(n - 1, p - K)) % mod) % mod;

    return memo;
}

void solve()
{
    for(int l = 1; l <= n; l++)
    {
        for(int pos = 0; pos < l; pos++)
        {
            int cnt = min(k, min(pos + 1, l - pos));
            prec[l][cnt]++;
        }

    }

    int mx = 0;
    for(int i = 1; i <= n; i++)
        mx += max(0, i - k + 1);

    if(p > mx)
    {
        cout << 0 << endl;
        return;
    }

    if(n == 1)
    {
        cout << 1 << endl;
        return;
    }

    if(k == 1)
    {
        if(p != mx)
        {
            cout << 0 << endl;
            return;
        }

        int ans = 1;
        for(int i = 1; i <= n; i++)
            ans = (ans * 1ll * i) % mod;

        cout << ans << endl;
        return;
    }

    memset(dp, -1, sizeof(dp));
    cout << rec(n, p) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

