/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  crypto
* score: 20.0
* date:  2017-11-25 11:02:39.532697
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (411);
const int mod = (int)1e9 + 7;

int read_int();

int n, P, k;

void read()
{
    cin >> n >> k >> P;
}

int dp[MAXN * MAXN][2];
int psum[MAXN * MAXN];

int get_sum(int l, int r)
{
    if(r < l) return 0;
    if(r < 0) return 0;
    if(l < 0) return psum[r];
    return (psum[r] - psum[l - 1] + mod) % mod;
}

void solve7()
{
    vector<int> perm;
    perm.resize(n);
    for(int i = 0; i < n; i++)
        perm[i] = i;

    int answer = 0;
    do
    {
        set<vector<int> > st_ans;
        set<int> st;
        for(int i = 0; i < n; i++)
        {
            st.clear();
            for(int j = i; j < n; j++)
            {
                st.insert(perm[j]);
                if(st.size() >= k)
                {
                    vector<int> curr;
                    auto it = st.begin();
                    for(int p = 0; p < k; p++)
                        curr.push_back(*(it)), it++;

                    st_ans.insert(curr);
                }

            }
        }

        if(P == st_ans.size()) answer++;

    }
    while(next_permutation(perm.begin(), perm.end()));

    cout << answer << endl;
}

void solve()
{
    int mx = 0;
    for(int i = 1; i <= n; i++)
        mx += max(0, i - k + 1);

    if(P > mx)
    {
        cout << 0 << endl;
        return;
    }

    if(n <= 7)
    {
        solve7();
        return;
    }

    dp[0][0] = 1;
    for(int i = 1; i <= n; i++)
    {
        int c = i & 1;

        if(i >= k)
        {
            for(int p = 0; p <= P; p++)
                psum[p] = ((p ? psum[p - 1] : 0) + dp[p][c ^ 1]) % mod;

            for(int p = 0; p <= P; p++)
            {
                int max_rem = min(k, i / 2);
                dp[p][c] = (get_sum(p - max_rem, p - 1) * 2ll) % mod;

                if(i <= 2 * k && (i % 2 == 1) && (p - max_rem - 1) >= 0) dp[p][c] = (dp[p][c] + dp[p - max_rem - 1][c ^ 1]) % mod;
                if(i > 2 * k && (p - k) >= 0) dp[p][c] = (dp[p][c] + (dp[p - k][c ^ 1] * 1ll * (i - (2ll * k))) % mod) % mod;
            }
        }
        else
        {
            for(int p = 0; p <= P; p++)
                dp[p][c] = (dp[p][c ^ 1] * 1ll * i) % mod;
        }
    }

    cout << dp[P][n & 1] << endl;

    /*
    memset(dp, -1, sizeof(dp));
    cout << rec(n, p) << endl;
    */
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

