/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  clubs
* score: 30.0
* date:  2017-11-25 07:14:57.330647
*/
#include <vector>
#include <iostream>
#include <cstdio>
#include <bitset>
#include <iomanip>
#include <set>
#include <cmath>
using namespace std;

set<int> get_pows2()
{
    set<int> pows;
    for(int i=1;i<1000000000;i*=2)pows.insert(i);
    return std::move(pows);
}

int n;
set<int> pows2=get_pows2();

bool is_pow2(int x)
{
    return pows2.find(x)!=pows2.end();
}

bool get_bit(int x, int index)
{
    return (x & (1<<index))!=0;
}


void solve()
{
    vector<vector<int>> clubs;
    int maxLen=-1;

    for(int bitmask=0;bitmask<n;bitmask++)
    {
        if(is_pow2(bitmask))
        {
            clubs.emplace_back();
        }

        for(int i=0;i<clubs.size();i++)
        {
            if(get_bit(bitmask, i))
            {
                clubs[i].push_back(bitmask+1);
                maxLen=max(maxLen, (int)clubs[i].size());
            }
        }
    }

    printf("%d %d\n", (int)clubs.size(), maxLen);

    for(const auto &club : clubs)
    {
        printf("%d ", (int)club.size());
        for(int x : club)printf("%d ", x);
        putchar('\n');
    }

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    solve();
}
/**
5
**/
