/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  clubs
* score: 50.0
* date:  2017-11-25 09:42:44.232839
*/
#include <bits/stdc++.h>
using namespace std;

int club_count(int n)
{
    //lowest number of clubs where there are at least N differtent
    //bit masks of size(CLUB_COUNT)
    for(int i=1;;i++)
    {
        if((1<<i)>=n)return i;
    }
}

int n, clubCount;

int one_count(int mask)
{
    if(mask==0)return 0;

    int res=0;
    for(int i=0;i<clubCount;i++)
    {
        if((mask & (1<<i))!=0)res++;
    }
    return res;
}

bool by_count(int x, int y)
{
    return one_count(x)<one_count(y);
}

void print_mask(int mask)
{
    for(int i=0;i<clubCount;i++)
    {
        printf("%d ", (int)((1<<i)&mask)!=0);
    }
    putchar('\n');
}

pair<int, int> solve()
{
    #ifndef EVAL
    //puts("smart: ");
    #endif // EVAL
    printf("%d ", clubCount);
    vector<int> possibleMasks;
    for(int i=0, c=1<<clubCount;i<c;i++)
    {
        possibleMasks.push_back(i);
    }

    sort(possibleMasks.begin(), possibleMasks.end(), by_count);

    int maxLen=0;
    vector<vector<int>> clubs;

    for(int i=0;i<n;i++)
    {
        int mask = possibleMasks[i];
        for(int club=0;club<clubCount;club++)
        {
            if((mask & (1<<club))!=0)
            {
                if(club>=clubs.size())clubs.resize(club+1);
                clubs[club].push_back(i+1);
                maxLen=max(maxLen, (int)clubs[club].size());
            }
        }
    }

    printf("%d\n", maxLen);
    for(auto &c : clubs)
    {
        printf("%d ", (int)c.size());
        for(int x : c)printf("%d ", x);
        putchar('\n');
    }

    return {clubCount, maxLen};
}

pair<int, int> dumb_solve()
{
    #ifndef EVAL
    //puts("dumb: ");
    #endif // EVAL

    vector<int> possibleMasks;
    for(int i=0, c=1<<clubCount;i<c;i++)
    {
        possibleMasks.push_back(i);
    }

    vector<int> indices;
    for(int i=0;i<possibleMasks.size();i++)indices.push_back(i);

    int minMaxLen=INT_MAX;
    do
    {
        int maxLen=0;
        vector<vector<int>> clubs;

        for(int i=0;i<n;i++)
        {
            int bitmask = possibleMasks[indices[i]];

            for(int club=0;club<32;club++)
            {
                if((bitmask & (1<<club))!=0)
                {
                    if(club>=clubs.size())clubs.resize(club+1);
                    clubs[club].push_back(i);
                    maxLen=max(maxLen, (int)clubs[club].size());
                }
            }
        }

        minMaxLen=min(minMaxLen, maxLen);
    }while(next_permutation(indices.begin(), indices.end()));

    printf("%d %d\n", clubCount, minMaxLen);
    return {clubCount, minMaxLen};
}

int main()
{
    cin>>n;
    clubCount=club_count(n);
    solve();
    //dumb_solve();
}
