/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 12:38:29.671119
*/
#include <vector>
#include <cstdio>
#include <map>
#include <set>
#include <tuple>
#include <cstdlib>
#include <queue>
#include <iostream>
using namespace std;

bool is_possible(int n, bool a, bool b)
{
    //printf("checking %d %d %d\n", n, (int)a, (int)b);
    bool one = (a!=b);
    bool both = (a&&b);
    bool none = !(a||b);

    if(none)return false;
    if(n==3)return one;

    return true;
}

int n;
bool shouldRed, shouldBlue;
vector<vector<bool>> redGr;
vector<vector<bool>> blueGr;
vector<vector<bool>> isRed;

void read()
{
    cin>>n;
    redGr.resize(n+1);
    blueGr.resize(n+1);
    isRed.resize(n+1, vector<bool>(n+1, false));
    for(int i=1;i<=n;i++)
    {
        redGr[i].resize(n+1);
        blueGr[i].resize(n+1);

        for(int j=1;j<=n;j++)
        {
            int x;
            cin>>x;
            redGr[i][j]=(x==0);
            blueGr[i][j]=(x!=0);
            isRed[i][j]=(x==0);
        }
    }

    ;;{
        int sri, sbi;
        cin>>sri>>sbi;
        shouldRed = (sri==1);
        shouldBlue=(sbi==1);
    }
}

struct edge
{
    int a, b;
    edge(int a, int b)
    {
        this->a=min(a, b);
        this->b=max(a, b);
    }

    bool operator < (const edge &e) const
    {
        return tie(a, b) < tie(e.a, e.b);
    }
};

bool is_connected(const vector<vector<bool>> &gr)
{
    vector<bool> used(gr.size(), false);
    queue<int> bfs;
    bfs.push(1);
    used[1]=true;
    int usedCount=1;

    while(!bfs.empty())
    {
        int x=bfs.front();
        bfs.pop();

        for(int y=2;y<=n;y++)if(gr[x][y]&&!used[y])
        {
            used[y]=true;
            bfs.push(y);
            usedCount++;
        }
    }

    return usedCount == n;
}

void apply(vector<vector<bool>> &gr, const set<edge> & changes)
{
    bool trace=false;

    if(trace)
    {
        for(edge e : changes)printf("(%d %d) ", e.a, e.b);
        putchar('\n');
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)printf("%d ", (int)gr[i][j]);
            putchar('\n');
        }
        putchar('\n');
    }

    for(edge e : changes)
    {
        gr[e.a][e.b]=!gr[e.a][e.b];
        gr[e.b][e.a]=!gr[e.b][e.a];
    }

    if(trace)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)printf("%d ", (int)gr[i][j]);
            putchar('\n');
        }
        putchar('\n');
    }
}

void print(const vector<vector<bool>> &gr, int indent=0)
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<indent;j++)putchar(' ');
        for(int j=1;j<=n;j++)
        {
            printf("%d ", (int)gr[i][j]);
        }
        putchar('\n');
    }
    putchar('\n');
}

bool check(const set<edge> & changed)
{
    apply(redGr, changed);
    apply(blueGr, changed);



    bool redConnected = is_connected(redGr);
    bool blueConnected = is_connected(blueGr);
    bool result= tie(redConnected, blueConnected) == tie(shouldRed, shouldBlue);

    //print(redGr, 2);
    //print(blueGr, 3);
    //printf("    %d %d\n", (int)redConnected, (int)blueConnected);

    apply(redGr, changed);
    apply(blueGr, changed);
    return result;
}

void print_answer(const set<edge> &changes)
{
    printf("%d\n", (int)changes.size());
    for(edge e : changes)printf("%d %d\n", e.a, e.b);
    putchar('\n');
}


void solve()
{
    if(!is_possible(n, shouldRed, shouldBlue))
    {
        puts("-1");
        exit(0);
    }

    queue<set<edge>> changeSets;
    changeSets.emplace();

    while(!changeSets.empty())
    {
        const set<edge> &current=changeSets.front();
        if(check(current))
        {
            print_answer(current);
            exit(0);
        }
        //for(edge x : current)printf("(%d %d) ", x.a, x.b);
        //putchar('\n');

        for(int i=1;i<n;i++)for(int j=i+1;j<=n;j++)
        {
            edge toChange(i, j);
            if(current.find(toChange)==current.end())
            {
                set<edge> next=current;
                next.insert(toChange);
                changeSets.push(next);
            }
        }

        changeSets.pop();
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();

}


/**
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1
*/
