/**
* user:  A1010
* fname: Plamen
* lname: Dinev
* task:  crypto
* score: 10.0
* date:  2017-11-25 10:30:08.652926
*/
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>
#include <utility>
#include <queue>
#include <set>
using namespace std;

#define MAXPRIME 2742
vector <uint16_t> primes;
vector <bool> is_not_prime;

void eratosten (uint32_t n)
{

    is_not_prime.resize(MAXPRIME);
    primes.push_back(2);n--;
    for(uint32_t i=2<<1; i<MAXPRIME; i+=2)
        is_not_prime[i]=true;
    uint32_t cur=3;
    while(n>0)
    {
        if(is_not_prime[cur]==false)
        {
            primes.push_back(cur);n--;
            for(uint32_t i=cur<<1; i<MAXPRIME; i+=cur)
                is_not_prime[i]=true;
        }
        cur+=2;
    }
}

uint32_t get_p(const vector<uint16_t> &primes, uint32_t k)
{
    vector<uint32_t> prs;
    prs.reserve(primes.size());
    for(uint16_t i=0; i<=primes.size()-k; i++)
    {
        uint32_t cur_pr=1;
        priority_queue<uint16_t> min_c;
        for(uint16_t j=0; j<k; j++)
        {
            min_c.push(primes[i+j]);
            cur_pr*=primes[i+j];
        }
        prs.push_back(cur_pr);
        //cout<<i<<" "<<k<<' '<<cur_pr<<endl;
        for(uint16_t j=k; i+j<primes.size(); j++)
        {
            min_c.push(primes[i+j]);
            cur_pr*=primes[i+j];
            cur_pr=cur_pr/min_c.top();
            //cout<<i<<' '<<j<<' '<<min_c.top()<<' '<<cur_pr<<endl;
            min_c.pop();
            prs.push_back(cur_pr);
        }
    }
    sort(prs.begin(), prs.end());
    //for(auto x:prs)
    //    cout<<x<<' ';
    //cout<<endl;
    uint32_t res=1;
    for(uint32_t i=1; i<prs.size(); i++)
        if(prs[i-1]!=prs[i])res++;
    return res;
}

uint16_t k;
uint32_t p;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint16_t n;
    cin>>n>>k>>p;
    eratosten(n);
}

uint32_t solve()
{
    uint32_t res=0;
    do
    {
        /*for(auto x: primes)
        {
            if(x==2)cout<<1<<' ';
            if(x==3)cout<<2<<' ';
            if(x==5)cout<<3<<' ';
            if(x==7)cout<<4<<' ';
        }
        cout<<get_p(primes, k)<<endl;*/
        if(get_p(primes, k)==p)res++;
    }while(next_permutation(primes.begin(), primes.end()));
    return res;
}

int main()
{
    init();
    cout<<solve()<<endl;
    /*vector<uint16_t> primes;
    primes.resize(4);
    primes[0]=5;
    primes[1]=2;
    primes[2]=7;
    primes[3]=3;
    cout<<get_p(primes, 2)<<endl;*/

    return 0;
}

