/**
* user:  A1010
* fname: Plamen
* lname: Dinev
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 12:24:52.389237
*/
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>
#include <utility>
#include <queue>
using namespace std;

vector < vector < uint16_t > > ss;
typedef struct
{
    uint16_t u, v;
    bool is_blue;
    bool test_is_blue;
} edge_t;
vector < edge_t > edges;

bool must_can_red, must_can_blue;

uint64_t colors=0;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint16_t n;
    cin>>n;
    ss.resize(n);
    edges.reserve(n*(n-1));
    for(uint16_t i=0; i<n; i++)
    {
        for(uint16_t j=0; j<n; j++)
        {
            bool is_blue;
            cin>>is_blue;
            if(i>j)
            {
                ss[i].push_back(edges.size());
                ss[j].push_back(edges.size());
                if(is_blue)colors |= (1<<edges.size());
                edge_t e;
                e.is_blue=is_blue;
                e.test_is_blue=is_blue;
                e.u=i;
                e.v=j;
                edges.push_back(e);
            }
        }
    }
    cin>>must_can_red>>must_can_blue;
}

bool is_possible(bool is_blue)
{
    vector<bool> used;
    used.resize(ss.size());
    used[0]=true;
    //cout<<"FAK"<<endl;
    queue<uint32_t> q;
    //cout<<"FAK2"<<endl;
    q.push(0);
    //cout<<"FAK3"<<endl;
    while(!q.empty())
    {
        uint32_t u=q.front();
        q.pop();
        for(auto x: ss[u])
        {
            if(edges[x].test_is_blue==is_blue)
            {
                uint32_t v;
                if(edges[x].u==u)v=edges[x].v;
                else v=edges[x].u;
                if(!used[v])
                {
                    used[v]=true;
                    q.push(v);
                }
            }
        }
    }
    for(auto x: used)
        if(x==false)return false;
    return true;
}

uint64_t res=UINT64_MAX;

void solve()
{
    for(uint64_t i=0; i<(1<<(ss.size()+1)); i++)
    {
        uint64_t new_colors=colors^i;
        uint8_t br=0;
        for(uint8_t i=0; i<64; i++)
        {
            edges[i].test_is_blue=(new_colors&(1<<i));
            br+=(new_colors&(1<<i));
        }
        if(must_can_red == is_possible(0)&&
           must_can_blue== is_possible(1))
        {
            res=max<uint64_t>(res,br);
        }
    }
}

int main()
{
    init();
    /*for(uint32_t i=0; i<ss.size(); i++)
    {
        cout<<i<<": ";
        for(uint32_t j=0; j<ss[i].size(); j++)
        {
            uint32_t v;
            if(edges[ss[i][j]].u==i)v=edges[ss[i][j]].v;
            else v=edges[ss[i][j]].u;
            cout<<v<<' ';
        }
        cout<<endl;
    }*/
    solve();
    //scout<<is_possible(0)<<' '<<is_possible(1)<<endl;
    cout<<res<<endl;

    return 0;
}
