/**
* user:  A1016
* fname: Yoana
* lname: Zelova
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 11:21:13.351968
*/
#include<bits/stdc++.h>
using namespace std;

bool isConnected(vector<vector<bool>>& v, int n)
{
    bool used[256];
    for(int i=1; i<=n; i++)
        used[i]=false;
    queue<int> q;
    q.push(1);
    used[1]=true;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int i=0; i<v[x].size(); i++)
        {
            if(!used[i] && v[x][i])
            {
                q.push(i);
                used[i]=true;
            }
        }
    }
    for(int i=1; i<=n; i++)
        if(!used[i]){return false;}
    return true;
}

int makeBalanced(vector<vector<bool>>& v, int& n, int id)
{
    int cur=id;
    while(true)
    {
        bool flag=false;
        for(int j=1; j<=n; j++)
        {
            if(v[cur][j])
            {
                int cntConnections=0;
                for(int k=1; k<=n; k++)
                    cntConnections+=v[j][k];
                if(cntConnections==n-1)
                {
                    flag=true;
                    v[id][j]=0;
                    v[j][id]=0;
                    cur=j;
                    break;
                }
            }
        }
        if(!flag)break;
    }
    bool flag=false;
    for(int j=1; j<=n; j++)
    {
        if(v[cur][j])
        {
            v[cur][j]=0;
            v[j][cur]=0;
            if(isConnected(v,n))
            {
                flag=true;
                break;
            }
            else
            {
                v[cur][j]=1;
                v[j][cur]=1;
            }
        }
    }
    if(flag)return 0;
    for(int j=1; j<=n; j++)
    {
        if(v[cur][j])
        {
            for(int k=1; k<=n; k++)
            {
                if(v[j][k]==0 && j!=k)
                {
                    int cntConnections=0;
                    for(int l=1; l<=n; l++)
                    {
                        cntConnections+=v[k][l];
                    }
                    if(cntConnections!=n-2)
                    {
                        //cout<<j<<" "<<k<<endl;
                        v[cur][j]=0;
                        v[j][cur]=0;
                        v[j][k]=1;
                        v[k][j]=1;
                        return 0;
                    }
                }
            }

        }
    }
    return -1;
}

int makeBlue(vector<vector<bool>>& v, int n)
{
    int id=0, m=0;
    for(int i=1; i<=n; i++)
    {
        int cnt=0;
        for(int j=1; j<=n; j++)
        {
            cnt+=v[i][j];
        }
        if(cnt>m)
        {
            m=cnt;
            id=i;
        }
    }
    for(int j=1; j<=n; j++)
        if(id!=j)
        {
            v[id][j]=1;
            v[j][id]=1;
        }
    return id;
}

void makeRed(vector<vector<bool>> &v, int n)
{
    int id=0, m=INT_MAX;
    for(int i=1; i<=n; i++)
    {
        int cnt=0;
        for(int j=1; j<=n; j++)
        {
            cnt+=v[i][j];
        }
        if(cnt<m)
        {
            m=cnt;
            id=i;
        }
    }
    for(int j=1; j<=n; j++)
        if(id!=j)
        {
            v[id][j]=0;
            v[j][id]=0;
        }
}

int main()
{
    int n;
    cin>>n;
    vector<vector<bool>> v, copy;
    v.resize(n+1, vector<bool>(n+1));
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            bool b;
            cin>>b;
            v[i][j]=b;
            if(i==j)v[i][j]=false;
        }
    }
    copy=v;
    bool a,b;
    cin>>a>>b;
    if(a==0 && b==0)
    {
        cout<<-1<<endl;
        return 0;
    }
    if(a==0 && b==1)
    {
        makeBlue(v, n);
    }
    if(a==1 && b==0)
    {
        makeRed(v, n);
    }
    if(a==1 && b==1)
    {
        int id;
        if(!isConnected(v,n))
        {
            id=makeBlue(v, n);
        }
        else
        {
            int m=0;
            for(int i=1; i<=n; i++)
            {
                int cntConnections=0;
                for(int k=1; k<=n; k++)
                    cntConnections+=v[i][k];
                if(m<cntConnections)
                {
                    m=cntConnections;
                    id=i;
                }
            }
        }
        if(makeBalanced(v, n, id)==-1)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    int cnt=0;
    vector<pair<int, int> > ans;
    for(int i=1; i<=n; i++)
    {
        for(int j=i+1; j<=n; j++)
        {
            if(v[i][j]!=copy[i][j])
            {
                cnt++;
                ans.push_back( {i, j});
            }
        }
    }
    cout<<cnt<<endl;
for(pair<int, int> p : ans)
        cout<<p.first<<" "<<p.second<<endl;
    return 0;
}
/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1

6
0 1 0 0 1 1
1 0 1 1 0 0
0 1 0 1 0 0
0 1 1 0 0 0
1 0 0 0 0 1
1 0 0 0 1 0
*/
