/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 12:07:30.949565
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 255;

struct Edge {
	int x, y, defaultColor;

	Edge(int x = 0, int y = 0, int defaultColor = 0) : x(x), y(y), defaultColor(defaultColor) {
		
	}
};

struct Node {
	bool vis;
	vector< Node* > v;

	Node() : vis(false) {
		v.clear();	
	}

	static void Init(Node *node);
	static void Dfs(Node *node);
};

vector< Edge > edges;
Node red[MAX_N], blue[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;

	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= n; j++) {
			int x;
			cin >> x;
		
			if(i >= j) {
				continue;
			}
	
			edges.push_back(Edge(i, j, x));
		}
	}

	int stateA, stateB;
	cin >> stateA >> stateB;

	if((stateA == 0 && stateB == 0) || (n == 3 && stateA == 1 && stateB == 1)) {
		cout << -1 << endl;
		return 0;
	}

	int cntEdges = edges.size(), minNeededToChange = edges.size();
	vector< pair< int, int > > ans, currAns;
	for(int i = 0; i < (1 << cntEdges); i++) {
		for(int j = 1; j <= n; j++) {
			Node::Init(&red[j]);
			Node::Init(&blue[j]);
		}
		currAns.clear();

		int cntMustBeChanged = 0;
		for(int j = 0; j < cntEdges; j++) {
			if((i & (1 << j)) != 0) {
				red[edges[j].x].v.push_back(&red[edges[j].y]);
				red[edges[j].y].v.push_back(&red[edges[j].x]);
				
				if(edges[j].defaultColor == 1) {
					cntMustBeChanged++;
					currAns.push_back({ edges[j].x, edges[j].y });
				}
			}
			else {
				blue[edges[j].x].v.push_back(&blue[edges[j].y]);
				blue[edges[j].y].v.push_back(&blue[edges[j].x]);
				
				if(edges[j].defaultColor == 0) {
					cntMustBeChanged++;
					currAns.push_back({ edges[j].x, edges[j].y });
				}
			}
		}

		if(cntMustBeChanged >= minNeededToChange) {
			continue;
		}

		Node::Dfs(&red[1]);
		Node::Dfs(&blue[1]);

		bool isPosRed = true;
		bool isPosBlue = true;
		for(int j = 1; j <= n; j++) {
			if(!red[j].vis) {
				isPosRed = false;
			}
			if(!blue[j].vis) {
				isPosBlue = false;
			}
		}

		if(isPosRed == stateA && isPosBlue == stateB) {
			minNeededToChange = cntMustBeChanged;
			ans = currAns;
		}
	}

	cout << ans.size() << endl;
	for(auto x : ans) {
		cout << x.first << " " << x.second << endl; 
	}

	return 0;
}

void Node::Init(Node *node) {
	node->vis = false;
	node->v.clear();
}

void Node::Dfs(Node *node) {
	node->vis = true;

	for(Node *nxt : node->v) {
		if(!nxt->vis) {
			Dfs(nxt);
		}
	}
}
