/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 12:17:19.381982
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 255;

struct Edge {
	bool isRemoved;
	int from, to, w;

	Edge(int from = 0, int to = 0, int w = 0, bool isRemoved = false) : from(from), to(to), w(w), isRemoved(isRemoved) {
		
	}

	bool operator< (const Edge &other) const;
};

struct UnionFind {
	int parents[MAX_N], heights[MAX_N];

	UnionFind() {
		memset(parents, -1, sizeof(parents));
		memset(heights, 0, sizeof(heights));
	}

	int Find(int x);
	void Unite(int x, int y);
};

vector< pair< int, int > > ans;
vector< Edge > edges;
UnionFind reds, blues;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;

	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= n; j++) {
			int x;
			cin >> x;

			if(i >= j) {
				continue;
			}

			edges.push_back(Edge(i, j, x, false));
		}
	}

	int stateA, stateB;
	cin >> stateA >> stateB;
	
	if(stateA == 0 && stateB == 0) {
		cout << -1 << endl;
		return 0;
	}
	else if(stateA == 1 && stateB == 1) {
		if(n == 3) {
			cout << -1 << endl;
			return 0;
		}

		sort(edges.begin(), edges.end());
	
		for(int i = 0; i < edges.size(); i++) {
			int rootX = reds.Find(edges[i].from);
			int rootY = reds.Find(edges[i].to);
	
			if(rootX == rootY) {
				reds.Unite(rootX, rootY);
				edges[i].isRemoved = true;
				
				if(edges[i].w == 1) {
					ans.push_back({ edges[i].from, edges[i].to });
				}
			}
		}

		for(int i = 0; i < edges.size(); i++) {
			if(!edges[i].isRemoved) {
				if(edges[i].w == 1) {
					edges[i].w = 0;
				}
				else {
					edges[i].w = 1;
				}
			}
		}
	
		sort(edges.begin(), edges.end());
	
		for(int i = 0; i < edges.size(); i++) {
			if(edges[i].isRemoved) {
				continue;
			}
	
			int rootX = blues.Find(edges[i].from);
			int rootY = blues.Find(edges[i].to);
			
			if(rootX != rootY) {
				blues.Unite(rootX, rootY);
	
				if(edges[i].w == 1) {
					ans.push_back({ edges[i].from, edges[i].to });
				}
			}
		}
	
		cout << ans.size() << endl;
		for(auto x : ans) {
			cout << x.first << " " << x.second << endl;
		}
	}
	else if(stateA == 0 && stateB == 1) {
		for(int i = 0; i < edges.size(); i++) {
			if(edges[i].w == 0) {
				degree[edges[i].from]++;
				degree[edges[i].to]++;
			}
		}

		for(int i = 1; i <= n; i++) {
			
		}
	}
	
	return 0;
}

bool Edge::operator< (const Edge &other) const {
	return w < other.w;
}

int UnionFind::Find(int x) {
	if(parents[x] == -1) {
		return x;
	}
	else {
		parents[x] = Find(parents[x]);
		return parents[x];
	}
}

void UnionFind::Unite(int x, int y) {
	if(heights[x] > heights[y]) {
		parents[y] = x;
	}
	else if(heights[x] < heights[y]) {
		parents[x] = y;
	}
	else {
		parents[y] = x;
		heights[x]++;
	}
}
