/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  clubs
* score: 30.0
* date:  2017-11-25 12:34:00.448774
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

struct SegmentTree {
	private:
		int treeSize;
		pair< int, int > data[3 * MAX_N];

		void Update(int node, int low, int high, int qInd, int qVal);
	public:
		SegmentTree(int treeSize = 0) : treeSize(treeSize) {
			
		}

		pair< int, int > Query();
		void Update(int ind, int val);
};

int CalcCntOnes(int n);
int LeftmostOneInd(int n);

set< int > clubs[MAX_N];
SegmentTree segTree;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	
	int removedNumber = 0, maxCntOnes = 0, maxOneInd = 0;
	for(int i = 1; i <= n; i++) {
		if(LeftmostOneInd(i) > maxOneInd) {
			maxCntOnes = CalcCntOnes(i);
			maxOneInd = LeftmostOneInd(i);
			removedNumber = i;
		}
		else if(LeftmostOneInd(i) == maxOneInd && CalcCntOnes(i) > maxCntOnes) {
			maxCntOnes = CalcCntOnes(i);
			removedNumber = i;
		}
	}

	int maxCntBits = 0;
	for(int i = 1; i <= n; i++) {
		if(i == removedNumber) {
			continue;
		}

		int currBit = 0;

		while((1 << currBit) <= i) {
			if(currBit + 1 > maxCntBits) {
				maxCntBits = currBit + 1;
			}

			if((i & (1 << currBit)) != 0) {
				clubs[currBit].insert(i);
			}
			
			currBit++;
		}
	}

	segTree = SegmentTree(maxCntBits);

	for(int i = 1; i <= n; i++) {
		if(i == removedNumber || CalcCntOnes(i) == 1) {
			continue;
		}

		int maxSize = 0, maxInd, minSize = MAX_N, minInd;
		for(int j = 0; j < maxCntBits; j++) {
			if((i & (1 << j)) != 0) {	
				if(clubs[j].size() > maxSize) {
					maxSize = clubs[j].size();
					maxInd = j;
				}
			}
			if(clubs[j].size() < minSize) {
				minSize = clubs[j].size();
				minInd = j;
			}
		}

		if(maxSize - minSize <= 1) {
			continue;
		}

		clubs[minInd].insert(i);
		clubs[maxInd].erase(i);
	}
	
	int maxCntInClub = 0;
	for(int i = 0; i < maxCntBits; i++) {
		maxCntInClub = max(maxCntInClub, (int) clubs[i].size());
	}

	cout << maxCntBits << " " << maxCntInClub << endl;
	for(int i = 0; i < maxCntBits; i++) {
		cout << clubs[i].size() << " ";
		for(int x : clubs[i]) {
			cout << x << " ";
		}
		cout << endl;
	}

	return 0;
}

void SegmentTree::Update(int node, int low, int high, int qInd, int qVal) {
	if(qInd < low || qInd > high) {
		return;
	}
	else if(qInd == low && qInd == high) {
		data[node].first = qVal;
		return;
	}

	int mid = (low + high) / 2;
	Update(2 * node, low, mid, qInd, qVal);
	Update(2 * node + 1, mid + 1, high, qInd, qVal);

	if(data[2 * node].first < data[2 * node + 1].first) {
		data[node] = data[2 * node];
	}
	else {
		data[node] = data[2 * node + 1];
	}
}

pair< int, int > SegmentTree::Query() {
	return data[1];
}

void SegmentTree::Update(int ind, int val) {
	Update(1, 1, treeSize, ind, val);
}

int CalcCntOnes(int n) {
	int currBit = 0, ans = 0;
	while((1 << currBit) <= n) {
		if((n & (1 << currBit)) != 0) {
			ans++;
		}
		currBit++;
	}
	
	return ans;
}

int LeftmostOneInd(int n) {
	int ans = 0;
	while(n > 0) {
		n >>= 1;
		ans++;
	}

	return ans;
}
