/**
* user:  A1034
* fname: Daniel
* lname: Danailov
* task:  colorgraph
* score: 35.0
* date:  2017-11-25 12:18:31.900479
*/
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

const int N=255;

int g[N][N],rc[N],bc[N];
int redcomp,bluecomp,total;
vector < pair <int,int> > ans,changed;
pair <int,int> edge[N];
bool used[N];
int n,p,q,mn;

void Clear()
{
 int i;

  for(i=1;i<=n;i++)
   used[i]=false;
}

void DFS(int v,int color,bool fl)
{
 int i;

 used[v]=true;

 if(fl)
 {
  if(color==0)
   rc[v]=redcomp;
  else
   bc[v]=bluecomp;
 }

  for(i=1;i<=n;i++)
   if(!used[i] && g[v][i]==color)
    DFS(i,color,fl);
}

void Check()
{
 int i,sz;

 sz=changed.size();

  if(mn!=-1 && sz>=mn)
   return;

 Clear();

 redcomp=0;
  for(i=1;i<=n;i++)
   if(!used[i])
   {
    redcomp++;
    DFS(i,0,true);
   }

 Clear();

 bluecomp=0;
  for(i=1;i<=n;i++)
   if(!used[i])
   {
    bluecomp++;
    DFS(i,1,true);
   }

 if(p==0 && q==0)
 {
  if(redcomp!=1 && bluecomp!=1)
  {
   mn=sz;
   ans=changed;
  }
 }

 if(p==0 && q==1)
 {
  if(redcomp!=1 && bluecomp==1)
  {
   mn=sz;
   ans=changed;
  }
 }

 if(p==1 && q==0)
 {
  if(redcomp==1 && bluecomp!=1)
  {
   mn=sz;
   ans=changed;
  }
 }

 if(p==1 && q==1)
 {
  if(redcomp==1 && bluecomp==1)
  {
   mn=sz;
   ans=changed;
  }
 }
}

void Solve(int num)
{
  if(num==total+1)
  {
   Check();
   return;
  }

 g[edge[num].first][edge[num].second]^=1;
 g[edge[num].second][edge[num].first]^=1;
 changed.push_back(make_pair(edge[num].first,edge[num].second));
 Solve(num+1);
 g[edge[num].first][edge[num].second]^=1;
 g[edge[num].second][edge[num].first]^=1;
 changed.pop_back();

 Solve(num+1);
}

int main()
{

int i,j,z,cnt,cc,sz;

scanf("%d",&n);

 for(i=1;i<=n;i++)
  for(j=1;j<=n;j++)
   scanf("%d",&g[i][j]);

scanf("%d%d",&p,&q);

 if(p==0 && q==0)
 {
  printf("-1\n");
  return 0;
 }

 if(n<=7)
 {
  mn=-1;

   for(i=1;i<=n;i++)
    for(j=i+1;j<=n;j++)
    {
     total++;
     edge[total]=make_pair(i,j);
    }

  Solve(1);

   if(mn==-1)
   {
    printf("-1\n");
    return 0;
   }

  sz=ans.size();

  printf("%d\n",sz);
   for(i=0;i<sz;i++)
    printf("%d %d\n",ans[i].first,ans[i].second);

  return 0;
 }

Clear();
redcomp=0;
 for(i=1;i<=n;i++)
  if(!used[i])
  {
   redcomp++;
   DFS(i,0,true);
  }

Clear();

bluecomp=0;
 for(i=1;i<=n;i++)
  if(!used[i])
  {
   bluecomp++;
   DFS(i,1,true);
  }

 for(i=1;i<=n;i++)
  for(j=i+1;j<=n;j++)
   if(rc[i]!=rc[j])
   {
    g[i][j]^=1;
    g[j][i]^=1;

    Clear();
    cnt=0;
     for(z=1;z<=n;z++)
      if(!used[z])
      {
       cnt++;
       DFS(z,1,false);
      }

     if(cnt==bluecomp)
     {
      ans.push_back(make_pair(i,j));
      redcomp--;
      cc=rc[j];
       for(z=1;z<=n;z++)
        if(rc[z]==cc)
         rc[z]=rc[i];
     }
     else
     {
      g[i][j]^=1;
      g[j][i]^=1;
     }
   }

 if(redcomp!=1)
 {
  printf("-1\n");
  return 0;
 }

 for(i=1;i<=n;i++)
  for(j=i+1;j<=n;j++)
   if(bc[i]!=bc[j])
   {
    g[i][j]^=1;
    g[j][i]^=1;

    Clear();
    cnt=0;
     for(z=1;z<=n;z++)
      if(!used[z])
      {
       cnt++;
       DFS(z,0,false);
      }

     if(cnt==redcomp)
     {
      ans.push_back(make_pair(i,j));
      bluecomp--;
      cc=bc[j];
       for(z=1;z<=n;z++)
        if(bc[z]==cc)
         bc[z]=bc[i];
     }
     else
     {
      g[i][j]^=1;
      g[j][i]^=1;
     }
   }

  if(redcomp!=1 && bluecomp!=1)
  {
   printf("-1\n");
   return 0;
  }

sz=ans.size();

printf("%d\n",sz);
  for(i=0;i<sz;i++)
   printf("%d %d\n",ans[i].first,ans[i].second);

return 0;
}
