/**
* user:  А1112
* fname: Георги Делянов Генков
* lname: Габрово
* task:  colorgraph
* score: 35.0
* date:  2017-11-25 09:47:45.514908
*/
#include <iostream>
#include <memory.h>
#include <set>

using namespace std;

int arr[256][256], n;
bool used[256];
int a,b;
set< pair<int,int> > changes;

int lastC1,lastC2,lastColor;

void printArr(){
     for(int i = 1; i <= n; i++){
            for(int j = 1; j <= n; j++){
                cout<<arr[i][j]<< " ";
            }
            cout<<endl;
     }
 }

void dfs(int start, int color)
{
    used[start] = true;
    for(int i = 1; i <= n; i++){
        if(i == start)continue;
        if (!used[i] && arr[start][i] == color){
            dfs(i,color);
        }
    }
}

bool check(int color){
    for(int i = 1; i <= n; i++){

        for(int j = 1; j <= n; j++){
                used[j] = false;
        }


        dfs(i, color);
        for(int j = 1; j <= n; j++){
            if(used[j] == false){
                lastC1 = i;
                lastC2 = j;
                lastColor = color;

                return false;
            }
        }
    }
    return true;
}

pair<int,int> minPair(int i, int j){
    if(i < j){
        return pair<int,int>(i,j);
    }else{
        return pair<int,int>(j,i);
    }

}


void fix(int i, int j, int color){

    pair<int,int> p = minPair(i,j);

    if(changes.count(p) == 0)
    {
        arr[i][j] = color;
        arr[j][i] = color;
        changes.insert(p);
        //cout<< "Changed1 " << i<< " "<< j << " to "<< color<<endl;
        return;
    }else{
        pair <int, int> p1,p2;
        for(int k = 1; k <= n; k++){
            p1 = minPair(j,k);
            p2 = minPair(i,k);
            if(k == i || k == j)continue;
            if(arr[i][k] == color && changes.count(p1) == 0){
                arr[k][j] = color;
                arr[j][k] = color;

                changes.insert(p1);
                //cout<< "Changed2 " << j << " "<< k << " to "<< color<<endl;
                return;
            }
            if(arr[k][j] == color && changes.count(p2) == 0){
                arr[i][j] = color;
                arr[j][i] = color;
                changes.insert(p2);
                //cout<< "Changed3 " << i << " "<< k << " to "<< color<<endl;
                return;
            }
        }
    }

}


int main(){

    cin>>n;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin>>arr[i][j];
        }
    }

    cin >> a >> b;

    while(true){
        if(changes.size() == (n * (n-1)) / 2) {
            cout<<-1<<endl;
            return 0;
        }

        if(check(0) == a){
            if(check(1) == b){
                //printArr();
                cout<<changes.size()<<endl;
                for(pair<int, int> p : changes){
                    cout<<p.first << " "<< p.second << endl;
                }
                break;
            }else{
                fix(lastC1,lastC2,lastColor);
            }
        }else{
            fix(lastC1,lastC2,lastColor);
        }

    }
}


   /* n = 3;
    arr[1][1] = 0; arr[1][2] = 1; arr[1][3] = 1;
    arr[2][1] = 1; arr[2][2] = 0; arr[2][3] = 0;
    arr[3][1] = 1; arr[3][2] = 0; arr[3][3] = 0;

    cout<<check(0)<<endl;
    cout<<check(1)<<endl;*/
