/**
* user:  А1112
* fname: Георги Делянов Генков
* lname: Габрово
* task:  colorgraph
* score: 40.0
* date:  2017-11-25 12:14:30.957163
*/
#include <iostream>
#include <memory.h>
#include <set>
#include <cmath>

using namespace std;

int arr[256][256], n;
int used[256];
int a,b;
set< pair<int,int> > changes;

int lastC1,lastC2,lastColor;

void printArr(){
     for(int i = 1; i <= n; i++){
            for(int j = 1; j <= n; j++){
                cout<<arr[i][j]<< " ";
            }
            cout<<endl;
     }
 }

 void printUsed(){
    for(int i = 1; i <= n; i++){
        cout<<used[i]<< " ";
    }
    cout<<endl;
 }


void dfs(int start, int color){
    for(int i = 1; i <= n; i++){
        if(i == start)continue;
        if (used[i] == 0 && arr[start][i] == color){
            used[i] = start;
            dfs(i,color);
        }
    }
}

bool check(int color){
    for(int i = 1; i <= n; i++){

        for(int j = 1; j <= n; j++){
                used[j] = 0;
        }

        used[i] = -1;
        dfs(i, color);
        for(int j = 1; j <= n; j++){
            if(i!= j && used[j] == 0){
                lastC1 = i;
                lastC2 = j;
                lastColor = color;
                return false;
            }
        }
    }
    return true;
}



pair<int,int> minPair(int i, int j){
    if(i < j){
        return pair<int,int>(i,j);
    }else{
        return pair<int,int>(j,i);
    }

}


void addPath(int i, int j, int color){
    pair<int,int> p = minPair(i,j);

    if(changes.count(p) == 0)
    {
        arr[i][j] = color;
        arr[j][i] = color;
        changes.insert(p);
       // cout<< "Changed1 " << i<< " "<< j << " to "<< color<<endl;
        return;
    }else{
        pair <int, int> p1,p2;
        for(int k = 1; k <= n; k++){
            p1 = minPair(j,k);
            p2 = minPair(i,k);
            if(k == i || k == j)continue;
            if(arr[i][k] == color && changes.count(p1) == 0){
                arr[k][j] = color;
                arr[j][k] = color;

                changes.insert(p1);
                //cout<< "Changed2 " << j << " "<< k << " to "<< color<<endl;
                return;
            }
            if(arr[k][j] == color && changes.count(p2) == 0){
                arr[i][j] = color;
                arr[j][i] = color;
                changes.insert(p2);
                //cout<< "Changed3 " << i << " "<< k << " to "<< color<<endl;
                return;
            }
        }
    }


}

void removePath(int color){
    int minC = 999999, minI,minJ;
    int cnt = 0,last = -1;
    for(int i = 1; i <= n; i++){
        cnt = 0;
        for(int j = 1; j <= n; j++){
            if(i != j && arr[i][j] == color){
                cnt++;
                last = j;

            }
        }
        if(cnt < minC){
            minC = cnt;
            minI = i;
            minJ = last;
        }
    }
    if(minC != 999999){
        pair<int,int> p = minPair(minI,minJ);
        if(changes.count(p) == 0){
            color = abs(color-1);
            arr[minI][minJ] = color;
            arr[minJ][minI] = color;

            changes.insert(p);
            //cout<<"Changed4 " <<minI << " " << minJ << " to " << color<<endl;
            return;
        }
    }
}

int main(){

    cin>>n;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin>>arr[i][j];
        }
    }

    cin >> a >> b;
    while(true){
        if(changes.size() == (n * (n-1)) / 2) {
            cout<<-1<<endl;
            return 0;
        }

        if(check(0) == a){
            if(check(1) == b){
                //printArr();
                cout<<changes.size()<<endl;
                for(pair<int, int> p : changes){
                    cout<<p.first << " "<< p.second << endl;
                }
                break;
            }else{
                //cout<<"Oh shit (1) "<< check(1) << "  " <<b << " at " <<lastC1<< " " << lastC2 <<endl;
                if(b == 1)addPath(lastC1,lastC2,lastColor);
                else removePath(1);

            }
        }else{
            //cout<<"Oh shit (0) "<< check(0) << " " << a << endl;
            if(a == 1)addPath(lastC1,lastC2,lastColor);
            else removePath(0);
        }
    }
}


