/**
* user:  А1112
* fname: Георги Делянов Генков
* lname: Габрово
* task:  clubs
* score: 0.0
* date:  2017-11-25 12:35:25.309628
*/
#include <iostream>
#include <set>
using namespace std;

int n;
int clubCount = 0;
set<int> clubs[100000];
int criticals [10000][10000];

int getSmallestValidClub(int i, int j){
    int minMembers = 200000, minId = -1;
    bool specialCase = false;
    for(int k = 1; k <= clubCount; k++){

        if(clubs[k].count(i) != 0 || clubs[k].size() < minMembers){

            if(clubs[k].count(i) != 0)specialCase=true;

            /* if club k is already a critical of either i or j and it is not in the club,
                then it cannot join it
            */
            bool isValid = true;
            for(int x = 1; x <= n; x++){
                if(i == x || j == x)continue;
                if(criticals[i][x] == k && clubs[k].count(i) == 0){
                    isValid = false;
                    break;
                }
                if(criticals[j][x] == k && clubs[k].count(j) == 0){
                    isValid = false;
                    break;
                }
            }

            if(!isValid)continue;

            //cout<< "  Found club " << k << " for " << i << " and " << j <<endl;
            minMembers = clubs[k].size();
            minId = k;

            if(specialCase) break;
        }
    }
    return minId;
}

bool check(){
    bool exists = false;
    for(int i = 1; i <= n-1; i++){
        for(int j = i + 1; j <= n; j++){
            for(int k = 1; k <= clubCount; k++){
                //cout<<i <<" " << j << " "<< k << " "<< clubs[k].count(i) << " " << clubs[k].count(j)<<endl;
                if(clubs[k].count(i) > 0 && clubs[k].count(j) == 0 ||
                   clubs[j].count(j) > 0 && clubs[j].count(i) == 0 ){
                   exists = true;
                   break;
                }
            }
            if(!exists)return false;
            exists = false;
        }

    }
    return true;
}

int main(){
    cin>>n;
    clubCount = 0;
    int largestClub = 0;
    while(!check()){
        clubCount++;
        //cout<< "Trying for club count of " << clubCount<<endl;

        for(int i = 1; i <= n ; i++){
            for(int j = 1; j <= n; j++){
                criticals[i][j] = 0;
            }
            clubs[i].clear();
        }
        bool isValid = true;

        for(int i = 1; i <= n - 1; i++){
            for(int j = 1; j <= n; j++){

                //cout<<" Checking for " << i << " " << j <<endl;
                if(i == j || criticals[i][j] != 0) continue;

                int c = getSmallestValidClub(i, j);

                if(c != -1){
                    clubs[c].insert(i);
                    criticals[i][j] = c;
                    criticals[j][i] = c;
                    //cout<<"   Made club " << c << " critical for members " << i << " and " << j <<endl;

                }else{
                    isValid = false;
                }

                if(!isValid)break;
            }
            if(!isValid)break;
        }
    }

    for(int k = 1; k <= clubCount; k++){
        if(clubs[k].size() >= largestClub){
            largestClub = clubs[k].size();
        }
    }

    cout<<clubCount << " " << largestClub << endl;
    for(int k = 1; k <= clubCount; k++){
        cout<< clubs[k].size();
        for(int i : clubs[k]){
            cout<< " " << i;
        }
        cout<<endl;
    }

}

