/**
* user:  А1117
* fname: Александър Христов Христов
* lname: София-град
* task:  colorgraph
* score: 25.0
* date:  2017-11-25 11:28:51.888831
*/
#include <bits/stdc++.h>
using namespace std;

#define REP(a,b) for(int i = (a); i < (b); i++)
#define REP2(a,b) for(int j = (a); j < (b); j++)
#define SZ(x) (x).size()
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define gcd __gcd
#define mod 1000000007
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> ii;
typedef vector<ii> vii;

ll xGCD(ll a, ll b, ll &x, ll &y){
    if(b == 0){
        x = 1, y = 0;
        return a;
    }
    ll x1, y1, g = xGCD(b,a%b,x1,y1);
    x = y1;
    y = x1 - (a/b)*y1;
}

ll powmod(ll a, ll b){
    ll res = 1;
    for(; b; b>>=1){
        if(b&1)res*=a, res%=mod;
        a*=a, a%=mod;
    }
    return res;
}

class unifind{
public:
    vi index, sizes;
    unifind(){
        REP(0,251){
            index.pb(i);
            sizes.pb(1);
        }
    }
    int root(int i){
        while(i!=index[i]){
            i = index[i] = index[index[i]];
        }
        return i;
    }
    void unite(int a, int b){
        a= root(a);
        b = root(b);
        if(a == b)return;
        if(sizes[a]>sizes[b])sizes[a]+=sizes[b], index[b] = a;
        else sizes[b]+=sizes[a], index[a] = b;
    }
    bool areConn(int a, int b){
        return root(a) == root(b);
    }
};

int V[251][251/32+1], temp[251][251/32+1], N;

bool bfs(int a, int b, int *par, int col){
    queue<int> Q;
    Q.push(a);
    bool used[251] = {0};
    used[a] = 1;
    while(!Q.empty()){
        int n = Q.front();
        Q.pop();
        REP(0,N){
            if(used[i])continue;
            if(bool(V[n][i/32] & (1<<(i%32)))==col){
                used[i]=1;
                Q.push(i);
                par[i] = n;
                if(i==b) return true;
            }
        }
    }
    return false;
}
bool areGood(int col){
    int all = N-1;
    stack<int> S;
    S.push(0);
    bool used[251] = {1};
    while(!S.empty()){
        int n = S.top();
        S.pop();
        REP(0,N){
            if(used[i])continue;
            if(bool(V[n][i/32] & (1<<(i%32)))==col){
                used[i]=1;
                all--;
                S.push(i);
            }
        }
    }
    if(all == 0)return true;
    else return false;
}
int max_flow(int tap, int sink, int col, bool sign = 0){
    int maxF = 0;
    int par[251];
    while(bfs(tap, sink, par, col)){
        maxF+=1;
        int curr = sink, currPar;
        if(sign)cout << par[curr]+1 << " " << curr+1 << endl;
        while(1){
            V[par[curr]][curr/32] ^= (1<<(curr%32));
            V[curr][par[curr/32]] ^= (1<<(par[curr]%32));
            if(par[curr] == tap){
                break;
            }
            curr = par[curr];
        }
    }
    REP(0,N){
        REP2(0,N/32+1){
            V[i][j] = temp[i][j];
        }
    }
    return maxF;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cin >> N;
    REP(0,N){
        REP2(0,N){
            int a;
            cin >> a;
            if(a)V[i][j/32] |= (1<<(j%32));
            if(a)temp[i][j/32] |= (1<<(j%32));
        }
    }
    int A, B;
    cin >> A >> B;
    if(A == 0){
        int mini = 2000000000, ind;
        REP(1,N){
            int res = max_flow(0,i,0);
            if(res < mini) mini = res, ind = i;
        }
        cout << mini << endl;
        if(mini!=0)max_flow(0,ind,0,1);
    }
    if(B == 0){
        int mini = 2000000000, ind;
        REP(1,N){
            int res = max_flow(0,i,1);
            if(res < mini) mini = res, ind = i;
        }
        cout << mini << endl;
        if(mini!=0)max_flow(0,ind,1,1);
    }
    bool redGood = areGood(0);
    bool bluGood = areGood(1);
    if(A == 1 && B == 1){
        vii ans;
        if(redGood && bluGood){
            cout << 0 << endl;
            return  0;
        }
        unifind U;
        if(redGood){// RED are good
            int eLeft = N-1;
            REP(0,N){
                REP2(0,N){
                    if(i == j)continue;
                    if(bool(V[i][j/32] & (1<<(j%32))) == 1){
                        if(U.areConn(i,j))continue;
                        eLeft--;
                        U.unite(i,j);
                    }
                }
            }
            REP(0,N){
                REP2(0,N){
                    if(i==j)continue;
                    if(bool(V[i][j/32] & (1<<(j%32))) == 0){
                        if(U.areConn(i,j))continue;
                        V[i][j/32] ^= (1<<(j%32));
                        V[j][i/32] ^= (1<<(i%32));
                        if(!areGood(0)){
                            V[i][j/32] ^= (1<<(j%32));
                            V[j][i/32] ^= (1<<(i%32));
                            continue;
                        }
                        eLeft--;
                        U.unite(i,j);
                        ans.pb(mp(i+1,j+1));
                        if(eLeft == 0){
                            cout << ans.size() << endl;
                            for(int k = 0; k < ans.size(); k++)cout << ans[k].fi << " " << ans[k].se << endl;
                            //cout << "red: " << areGood(0) << " blue: " << areGood(1) << endl;
                            return 0;
                        }
                    }
                }
            }
        }else if(bluGood){
            int eLeft = N-1;
            REP(0,N){
                REP2(0,N){
                    if(i==j)continue;
                    if(bool(V[i][j/32] & (1<<(j%32))) == 0){
                        if(U.areConn(i,j))continue;
                        eLeft--;
                        U.unite(i,j);
                    }
                }
            }
            REP(0,N){
                REP2(0,N){
                    if(i==j)continue;
                    if(bool(V[i][j/32] & (1<<(j%32))) == 1){
                        if(U.areConn(i,j))continue;
                        V[i][j/32] ^= (1<<(j%32));
                        V[j][i/32] ^= (1<<(i%32));
                        if(!areGood(1)){
                            V[i][j/32] ^= (1<<(j%32));
                            V[j][i/32] ^= (1<<(i%32));
                            continue;
                        }
                        eLeft--;
                        U.unite(i,j);
                        ans.pb(mp(i+1,j+1));
                        if(eLeft == 0){
                            cout << ans.size() << endl;
                            for(int k = 0; k < ans.size(); k++)cout << ans[k].fi << " " << ans[k].se << endl;
                            //cout << "red: " << areGood(0) << " blue: " << areGood(1) << endl;
                            return 0;
                        }
                    }
                }
            }

        }
        cout << -1 << endl;
    }
}
/*
4
1 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
1 1

4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

4
0 1 1 1
1 1 0 1
1 0 0 1
1 1 1 1
1 0

5
1 0 0 0 1
0 1 0 1 1
0 0 1 1 0
0 1 1 1 0
1 1 0 0 1
0 1
*/

