/**
* user:  А1121
* fname: Иван Даниелов Иванов
* lname: София-град
* task:  colorgraph
* score: 35.0
* date:  2017-11-25 12:35:29.965747
*/
#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
int input[251][251],n,revnum[251][251];
bool used[251];
void dfs(int v,int state,int type){
	used[v]=true;
	for(int i=0;i<n;i++){
		int nval=input[v][i];
		if(state&(1<<revnum[i][v])){
			nval^=1;
		}
		if(!used[i]&&nval==type){
			dfs(i,state,type);
		}
	}
}
void dfsN(int v,int type){
	used[v]=true;
	for(int i=0;i<n;i++){
		if(!used[i]&&input[i][v]==type){
			dfsN(i,type);
		}
	}
}
struct edge{
	int from,to,price;
	edge(){};
	edge(int a,int b,int c){
		this->from=a;
		this->to=b;
		this->price=c;
	}
}edges[250*250+1];
bool operator<(edge a,edge b){
	return a.price<b.price;
}
int fathers[251];
int find(int v){
	if(fathers[v]==v){
		return v;
	}
	fathers[v]=find(fathers[v]);
	return fathers[v];
}
void unionFind(int x,int y){
	int a=find(x);
	int b=find(y);
	fathers[a]=b;
}
int calcAns(int type){
	int cnt=0;
	for(int i=0;i<n;i++){
		for(int j=0;j<n;j++){
			if(input[i][j]==type){
				edges[cnt++]=edge(i,j,0);
			}else{
				edges[cnt++]=edge(i,j,1);
			}
		}
		fathers[i]=i;
	}
	sort(edges,edges+cnt);
	int ans=0;
	vector<int> moves;
	for(int i=0;i<cnt;i++){
		if(find(edges[i].from)!=find(edges[i].to)){
			unionFind(edges[i].from,edges[i].to);
			if(edges[i].price!=0){
				ans++;
				moves.push_back(edges[i].from*n+edges[i].to);
			}
		}
	}
	int fatherU=find(0);
	for(int i=1;i<n;i++){
		if(find(i)!=fatherU){
			cout<<"-1\n";
			return 0;
		}
	}
	cout<<ans<<"\n";
	for(int i=0;i<ans;i++){
		cout<<moves[i]%n+1<<" "<<moves[i]/n+1<<"\n";
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	cin>>n;
	for(int i=0;i<n;i++){
		for(int j=0;j<n;j++){
			cin>>input[i][j];
		}
	}
	int stateRed,stateBlue;
	cin>>stateRed>>stateBlue;
	if(n<=7){
		int br=0;
		for(int i=0;i<n;i++){
			for(int j=i+1;j<n;j++){
				revnum[i][j]=br;
				revnum[j][i]=br++;
			}
		}
		int minx=br+1,minState=0;
		for(int j=0;j<(1<<br);j++){
			dfs(0,j,0);
			int visitedRed=0;
			for(int i=0;i<n;i++){
				visitedRed+=used[i];
				used[i]=false;
			}
			dfs(0,j,1);
			int visitedBlue=0;
			for(int i=0;i<n;i++){
				visitedBlue+=used[i];
				used[i]=false;
			}
			if(((visitedRed!=n&&!stateRed)||(visitedRed==n&&stateRed))&&((visitedBlue!=n&&!stateBlue)||(visitedBlue==n&&stateBlue))){
				int cnt=0,pom=j;
				while(pom!=0){
					cnt+=pom%2;
					pom/=2;
				}
				if(minx>cnt){
					minx=cnt;
					minState=j;
				}
			}
		}
		if(minx==br+1){
			cout<<"-1\n";
			return 0;
		}
		cout<<minx<<"\n";
		for(int a=0;a<n;a++){
			for(int b=a+1;b<n;b++){
				if(minState&(1<<revnum[a][b])){
					cout<<a+1<<" "<<b+1<<"\n";
				}
			}
		}
	}else{
		dfsN(0,0);
		int visitedRed=0;
		for(int i=0;i<n;i++){
			visitedRed+=used[i];
			used[i]=false;
		}
		dfsN(0,1);
		int visitedBlue=0;
		for(int i=0;i<n;i++){
			visitedBlue+=used[i];
			used[i]=false;
		}
		if(visitedRed!=n&&visitedBlue!=n){ //0,0
			if(stateRed==0&&stateBlue==0){
				cout<<"0\n";
			}
			if(stateRed==0&&stateBlue==1){
				calcAns(1);
			}
			if(stateRed==1&&stateBlue==0){
				calcAns(0);
			}
			if(stateRed==1&&stateBlue==1){
				calcAns(n%2);
			}
		}
		if(visitedRed==n&&visitedBlue!=n){ //1,0
			if(stateRed==0&&stateBlue==0){
				calcAns(n%2);
			}
			if(stateRed==0&&stateBlue==1){
				calcAns(1);
			}
			if(stateRed==1&&stateBlue==0){
				cout<<"0\n";
			}
			if(stateRed==1&&stateBlue==1){
				calcAns(1);
			}
		}
		if(visitedRed!=n&&visitedBlue==n){ //0,1
			if(stateRed==0&&stateBlue==0){
				calcAns(n%2);
			}
			if(stateRed==0&&stateBlue==1){
				cout<<"0\n";
			}
			if(stateRed==1&&stateBlue==0){
				calcAns(0);
			}
			if(stateRed==1&&stateBlue==1){
				calcAns(0);
			}
		}
		if(visitedRed==n&&visitedBlue==n){ //1,1
			if(stateRed==0&&stateBlue==0){
				calcAns(n%2);
			}
			if(stateRed==0&&stateBlue==1){
				calcAns(1);
			}
			if(stateRed==1&&stateBlue==0){
				calcAns(0);
			}
			if(stateRed==1&&stateBlue==1){
				cout<<"0\n";
			}
		}
	}
	return 0;
}
